package com.st.p2012.mind.adl;

import java.util.Map;

import org.objectweb.fractal.adl.ADLException;
import org.objectweb.fractal.adl.AbstractLoader;
import org.objectweb.fractal.adl.Definition;
import org.objectweb.fractal.mind.adl.DefinitionReferenceResolver;
import org.objectweb.fractal.mind.adl.ast.DefinitionReference;
import org.objectweb.fractal.mind.adl.ast.MindDefinition;

public class ExtendsDecorationLoader extends AbstractLoader {

  /** The interface used to resolve referenced definitions. */
  public DefinitionReferenceResolver  definitionReferenceResolverItf;

  public Definition load(final String name, final Map<Object, Object> context)
      throws ADLException {
    Definition d = clientLoader.load(name, context);
    if(d instanceof MindDefinition) {
      d = addDecorations((MindDefinition) d, context);
    }
    return d;
  }

  private MindDefinition addDecorations(final MindDefinition d, final Map<Object, Object> context) throws ADLException {
    if (d.getExtends() == null) return d;

    final ExtendsDecoration list = new ExtendsDecoration();

    for (final DefinitionReference extend : d.getExtends().getDefinitionReferences()) {
      list.add(extend);
    }

    d.astSetDecoration("extends", list);

    return d;
  }
}
