/**
 \file com/st/p2012/mind/comments/CommentTag.java
 \brief An abstract class to represent a tag in a comment.


 <B>
 \n
 This file is part of the Platform 2012 program,
 a cooperation between STMicroelectronics and CEA.\n
 Redistribution of this file to outside parties is
 strictly prohibited without the written consent
 of the module owner indicated below.\n
 </B>

 \par  Module owner: michel.metzger@st.com


 \par  Copyright (C) 2009 STMicroelectronics

 \par  Authors: michel.metzger@st.com

 \par  Id: $Id$
 \par  Date: $Date$
 \par  Revision: $Rev$

 */

package com.st.p2012.mind.comments;

import com.st.p2012.mind.HTMLDocumentationHelper;

public abstract class CommentTag {

  protected final int beginIndex;
  protected final int endIndex;

  protected CommentTag(final int beginIndex, final int endIndex) {
    this.beginIndex = beginIndex;
    this.endIndex = endIndex;
  }

  public abstract String getReplacement(final String definitionName,
      HTMLDocumentationHelper.SourceKind sourceKind);


  public static class Comparator implements java.util.Comparator<CommentTag> {

    public int compare(final CommentTag tag1, final CommentTag tag2) {
      return tag1.beginIndex - tag2.beginIndex;
    }

  }
}